#include "window9.bi"
#include "declares.bi"
#include "parsecommand.bi"
#include "crt/iconv.bi"
#include "crt/linux/unistd.bi"
#include "encoding.bi"
#include "replace.bi"
#include "mnemonic.bi"
#include "chm_lib.bi"
#include "panedgui.bi"
#include "xmlparser.bi"
#include "web.bi"
#include "chm_get_fill.bi"
#include "files.bi"
#include "guicallback.bi"
#include "search.bi"
#include "dialogs.bi"
#include "gui_resize.bi"

parsecommand()

If Len(sCommArr(3)) Then
	
	chmlist(sCommArr(3))
	
	End
	
Endif

load_options()

load_options_for_help_files(sCommArr(0))

If iCurentEncParam <> -1 Then
	
	iCurentEnc = iCurentEncParam
	
Endif

Includebinary("icons/ul0.png",hgMem1)
Includebinary("icons/ul1.png",hgMem2)
Includebinary("icons/li.png",hgMem3)
Includebinary("icons/do.png",hgMem4)
Includebinary("icons/dp.png",hgMem5)
Includebinary("icons/zi.png",hgMem6)
Includebinary("icons/zo.png",hgMem7)
Includebinary("icons/undo.png",hgMem8)
Includebinary("icons/redo.png",hgMem9)
Includebinary("icons/sc.png",hgMem10)
Includebinary("icons/h.png",hgMem11)
bmp_ul0 = Catch_image(hgMem1,&hFF000000)
bmp_ul1 = Catch_image(hgMem2,&hFF000000)
bmp_li = Catch_image(hgMem3,&hFF000000)
bmp_do = Catch_image(hgMem4,&hFF000000)
bmp_dp = Catch_image(hgMem5,&hFF000000)
bmp_zi = Catch_image(hgMem6,&hFF000000)
bmp_zo = Catch_image(hgMem7,&hFF000000)
bmp_undo = Catch_image(hgMem8,&hFF000000)
bmp_redo = Catch_image(hgMem9,&hFF000000)
bmp_sc = Catch_image(hgMem10,&hFF000000)
bmp_h = Catch_image(hgMem11,&hFF000000)

mhwnd=Openwindow("",10,10,iWmHwnd , iHmHwnd , WS_OVERLAPPEDWINDOW Or WS_TABSTOPENABLE)

Centerwindow(mhwnd)

Hidewindow(mHwnd , 0)

Windowbounds(mhwnd,200,200,5000,2000)

hMenu = Createpopmenu()

hSubMenu = Opensubmenu(hMenu,"Encoding")

For i As Long = 0 To 21
	
	Menuitem(1000+i , hSubMenu , szEncodingString(i))
	
	If i = iCurentEnc Then
		
		Setstatemenu(hMenu , 1000+i , 3)
		
	Endif
	
Next

Menuitem(1022 , hMenu , "Set path for temp files")

hwToolBar=Createtoolbar(,style)

Toolbarimagebutton(hwToolBar,E_TB_OPEN,bmp_do)

Toolbartooltip(Cast(hwnd , hwToolBar),E_TB_OPEN,"Open CHM file")

Toolbarseparator(hwToolBar)

Toolbarimagebutton(hwToolBar,E_TB_UNDO,bmp_undo)

Toolbartooltip(Cast(hwnd , hwToolBar),E_TB_UNDO,"Back to previous page")

Toolbarimagebutton(hwToolBar,E_TB_REDO,bmp_redo)

Toolbartooltip(Cast(hwnd , hwToolBar),E_TB_REDO,"Back to next page")

Toolbarseparator(hwToolBar)

Toolbarimagebutton(hwToolBar,E_TB_ZOOM_IN,bmp_zi)

Toolbartooltip(Cast(hwnd , hwToolBar),E_TB_ZOOM_IN,"Zoom in")

Toolbarimagebutton(hwToolBar,E_TB_ZOOM_OUT,bmp_zo)

Toolbartooltip(Cast(hwnd , hwToolBar),E_TB_ZOOM_OUT,"Zoom out")

Toolbarseparator(hwToolBar)

Toolbarimagebutton(hwToolBar,E_TB_SOURCECODE,bmp_sc)

Toolbartooltip(Cast(hwnd , hwToolBar),E_TB_SOURCECODE,"Get html source code page")

Toolbarimagebutton(hwToolBar,E_TB_PROP,bmp_dp)

Toolbartooltip(Cast(hwnd , hwToolBar),E_TB_PROP,"Encoding...")

Toolbarimagebutton(hwToolBar,E_TB_HELP,bmp_h)

Toolbartooltip(Cast(hwnd , hwToolBar),E_TB_HELP,"Help")

PanedGadget(E_PANED_GOR , 1 , 40 , 798 , 520 ,  iSharedPanedPosition ,  1)

Containergadget(E_CONTAINER1,0,0,200,520)

Panelgadget(E_PANEL, 0 , 0 , 200 , 520)

panel1 = Addpanelgadgetitem(E_PANEL,0,"Contents",0,1)

tree=Treeviewgadget(E_TREE,0,0,190,440)

panel2 = Addpanelgadgetitem(E_PANEL,1,"Index",0,1)

Stringgadget(E_STRING_INDEX,0,10,190,30)

Listboxgadget(E_LISTBOX_INDEX,0,50,190,390) 

panel3 = Addpanelgadgetitem(E_PANEL,2,"Search",0,1)

Stringgadget(E_STRING_SEARCH,0,10,iSharedPanedPosition - 58,30)

Buttongadget(E_BUTTON_SEARCH,iSharedPanedPosition - 53,10,35,30 , "OK") 

Listboxgadget(E_LISTBOX_SEARCH,0,50,190,390)

g_signal_connect(G_OBJECT(tree), "cursor-changed", G_CALLBACK (@cursor_change_cb), 0)

g_signal_connect(G_OBJECT(tree), "key-press-event", G_CALLBACK (@key_press_cb), 0)

Usegadgetlist(Gadgetid(E_PANED_GOR))

Containergadget(E_CONTAINER2,0,0,595,520)

web=Webgadget(E_WEB,0,0,590,520,"about:blank")

#ifdef __USE_GTK3__
	
	g_signal_connect(G_OBJECT(web), "load-changed", G_CALLBACK (@load_changes_cb), 0)
	
#else
	
	webkit_web_view_set_full_content_zoom(web,True)
	
	g_signal_connect(G_OBJECT(web), "load-finished", G_CALLBACK (@load_changes_cb), 0)
	
#endif

webkit_web_view_set_custom_encoding(web , szEncodingString(iCurentEnc))

Updateinfoxserver(15000)

PanedGadgetAddGadget(E_PANED_GOR , E_CONTAINER1 , E_CONTAINER2)

iwPrev = iWmHwnd 

ihPrev = iHmHwnd

If Len(sCommArr(0)) Then
	
	openfilechm(sCommArr(0) , sCommArr(1) , sCommArr(2) , 1)
	
Endif

init_resize()

Addkeyboardshortcut(mHwnd,FVIRTKEY,VK_RETURN,E_BUTTON_SEARCH)

Do
	
	Var ev=Waitevent
	
	If ev=Eventclose Then
		
		If Eventhwnd = dlgsc Then
			
			Close_window(dlgsc)
			
			dlgsc = 0
			
		Elseif Eventhwnd = dlgsf Then
			
			Close_window(dlgsf)
			
			dlgsf = 0
			
		Elseif Eventhwnd = mHwnd Andalso dlgsf = 0 Then
			
			Deletedir(sDirChm,64)
			
			save_options()
			
			If iOpenIs Then
				
				save_options_for_help_files()
				
			Endif
			
			End
			
		Endif
		
	Elseif ev=Eventgadget Then
		
		Select Case Eventnumbertoolbar
				
			Case E_TB_OPEN
				
				Var sFile = Openfilerequester("Open CHM File" , *getpwuid(getuid())->pw_dir ,"CHM files (*.chm)"+Chr(0)+"*.chm"+Chr(0) , , , mhwnd)
				
				openfilechm(sFile , "" , "")
				
			Case E_TB_UNDO
				
				Webgadgetgoback(web)
				
			Case E_TB_REDO
				
				Webgadgetgoforward(web)
				
			Case E_TB_ZOOM_IN
				
				#ifdef __USE_GTK3__
					webkit_web_view_set_zoom_level(web , webkit_web_view_get_zoom_level(web)+0.1)
				#else
					webkit_web_view_set_zoom_level(web , webkit_web_view_get_zoom_level(web)+0.005e-315)
				#endif
				
			Case E_TB_ZOOM_OUT
				
				#ifdef __USE_GTK3__
					webkit_web_view_set_zoom_level(web , webkit_web_view_get_zoom_level(web)-0.1)
				#else
					webkit_web_view_set_zoom_level(web , webkit_web_view_get_zoom_level(web)-0.005e-315)
				#endif
				
			Case E_TB_SOURCECODE
				
				getwebhtml()
				
			Case E_TB_PROP
				
				Displaypopupmenu(hMenu, Globalmousex,Globalmousey)
				
			Case E_TB_HELP
				
				Messbox("Help" , sHelpInfo ,  , mHwnd)
				
			Case E_BUTTON_SEARCH
				
				Dim As String sFind = Getgadgettext(E_STRING_SEARCH)
				
				search(sFind)
				
			Case E_LISTBOX_INDEX
				
				If Countitemlistbox(E_LISTBOX_INDEX) Then
					
					navigate(szArrKeyWords(Getitemlistbox(E_LISTBOX_INDEX)).szPath)
					
					iIndexNavigateFlag = 1
					
				Endif
				
			Case E_LISTBOX_SEARCH
				
				If Countitemlistbox(E_LISTBOX_SEARCH) Then
					
					Dim As Long iItem = Getitemlistbox(E_LISTBOX_SEARCH)
					
					If iItem > -1 Then
						
						Dim As String sPath = Getlistboxtext(E_LISTBOX_SEARCH , iItem)
						
						If Len(sPath) Then
							
							navigate(sPath)
							
							iIndexNavigateFlag = 1
							
						Endif
						
					Endif
					
				Endif				
				
			Case E_STRING_INDEX
				
				If Countitemlistbox(E_LISTBOX_INDEX) Then
					
					Dim As String sTemplate = Lcase(Getgadgettext(E_STRING_INDEX))
					
					For i As Long = 0 To Ubound(szArrKeyWords)
						
						If Lcase(Left(szArrKeyWords(i).szName , Len(sTemplate))) =  sTemplate Then
							
							Settopindexlistbox(E_LISTBOX_INDEX , i)
							
							Exit For
							
						Endif
						
					Next
					
				Endif
				
			Case E_PANEL
				
				iIndexNavigateFlag = 0
				
			Case E_BUTTON_SF
				
				Dim As String sDir = Openfilerequester("Select path" , "/tmp" ,"**"+Chr(0) , OFN_DIRECTORY , , mHwnd)
				
				If Len(sDir) > 1 Then
					
					If Right(sDir , 1) = "/" Then
						
						sDir = Left(sDir, Len(sDir)-1)
						
					Endif
					
					If checkDir(sDir) = 0 Then
						
						Messbox("Error" , "This directory cannot be used!" , , mHwnd)
						
					Else
						
						Setgadgettext(E_IDIT_SF , sDir)
						
					Endif
					
				Endif
				
			Case E_BUTTON_SF_OK
				
				Dim As String sDir = Getgadgettext(E_IDIT_SF)
				
				If checkDir(sDir) = 0 Then
					
					Messbox("Error" , "This directory cannot be used!")
					
				Else
					
					sDirInitial = sDir
					
					Close_window(dlgsf)
					
					dlgsf = 0
					
				Endif

		End Select
		
	Elseif ev=Eventsize Then
		
		resize_win()
		
	Elseif ev=Eventmenu Then
		
		Dim As Long iNumMenu = Eventnumber
		
		If iNumMenu = E_BUTTON_SEARCH Then
			
			If Panelgadgetgetcursel(E_PANEL) = 2 Then
				
				Dim As String sFind = Getgadgettext(E_STRING_SEARCH)
				
				search(sFind)
				
			Endif
			
		Elseif iNumMenu = 1022 Then
			
			create_dialog_select_path()
			
		Else
			
			For i As Long = 1000 To 1021
				
				Setstatemenu(hMenu , i , 0)
				
			Next
			
			Setstatemenu(hMenu , iNumMenu , 3)
			
			iCurentEnc = iNumMenu - 1000
			
			set_encoding()
			
		Endif
		
	Endif
	
Loop