Enum chmenum
	
	E_TB_OPEN = 1
	E_TB_UNDO
	E_TB_REDO
	E_TB_ZOOM_IN
	E_TB_ZOOM_OUT
	E_TB_SOURCECODE
	E_TB_PROP
	E_TB_HELP
	E_PANED_GOR
	E_TREE
	E_WEB
	E_CONTAINER1
	E_CONTAINER2
	E_PANEL
	E_STRING_INDEX
	E_LISTBOX_INDEX
	E_STRING_SEARCH
	E_BUTTON_SEARCH
	E_LISTBOX_SEARCH
	E_EDITOR_SC
	E_IDIT_SF
	E_BUTTON_SF
	E_BUTTON_SF_OK
	E_TEXT_SF
	
End Enum

Enum WK
	WEBKIT_LOAD_STARTED
	WEBKIT_LOAD_REDIRECTED
	WEBKIT_LOAD_COMMITTED
	WEBKIT_LOAD_FINISHED
End Enum

Extern "C"

	Type passwd
		
		pw_name As Zstring Ptr
		
		pw_passwd As Zstring Ptr
		
		pw_uid As uid_t
		
		pw_gid As gid_t
		
		pw_gecos As Zstring Ptr
		
		pw_dir As Zstring Ptr
		
		pw_shell As Zstring Ptr
		
	End Type
	
	#ifdef __USE_GTK3__
		Declare Sub webkit_web_view_set_custom_encoding Alias "webkit_web_view_set_custom_charset"(web_view As  Any Ptr,  enc As gchar Ptr)
		Declare Function webkit_web_resource_get_data_finish(resource As Any Ptr,result As GAsyncResult Ptr,length As gsize Ptr,err_ As GError Ptr Ptr) As Zstring Ptr
		Declare Function webkit_web_view_get_main_resource(web_view As  Any Ptr) As Any Ptr
		Declare Sub webkit_web_resource_get_data(resource As Any Ptr,cancellable As Any Ptr , cb As Any Ptr , p As gpointer)
		Declare Sub webkit_web_view_load_html(web_view As  Any Ptr , text As gchar Ptr , base_uri As gchar Ptr = 0)
		Declare Function webkit_network_request_get_uri Alias "webkit_uri_request_get_uri"(As Any Ptr) As Const gchar Ptr	
	#else
		Declare Sub webkit_web_view_set_custom_encoding(web_view As  Any Ptr,  enc As gchar Ptr)
		Declare Sub webkit_web_view_set_full_content_zoom(web_view As  Any Ptr , flag As gboolean)
		Declare Sub webkit_web_view_load_html Alias "webkit_web_view_load_html_string"(web_view As  Any Ptr , text As gchar Ptr , base_uri As gchar Ptr = 0)
		Declare Function webkit_network_request_get_uri(As Any Ptr) As Const gchar Ptr
		Declare Function webkit_web_frame_get_uri(As Any Ptr) As gchar Ptr
	#endif
	
	Declare Sub webkit_web_view_set_zoom_level(web_view As  Any Ptr, z As gdouble)	
	Declare Function webkit_web_view_get_zoom_level(web_view As  Any Ptr) As gdouble	
	
	Declare Function getpwuid( uid As uid_t) As passwd Ptr	
	Declare Function towlower (ch As wint_t) As Long
	
End Extern

Declare Function createfile(sPath As String) As handle
Declare Sub create_dialog_source_code(sData As String)
Declare Sub displayhtml(sPath As String)
Declare Sub save_options_for_help_files()
Declare Sub load_options_for_help_files(sPath As String)

#ifdef __fb_win32__
	Var style = TBSTYLE_FLAT Or 256
#else
	Var style = 256
#endif

Type TNAMEPATH
	
	szName As Zstring*100
	
	szPath As Zstring*512
	
	szAnchor As Zstring*100
	
End Type

Type TPAGE Extends TNAMEPATH
	
	h As Integer
	
End Type

Dim Shared As String sDirChm , sDirInitial 

Dim Shared As Hwnd mhwnd , dlgsc , dlgsf , tree , panel1 , panel2 , panel3
Dim Shared As Any Ptr web
Dim Shared As HMENU hMenu , hSubMenu
Dim Shared As Integer hwToolBar , iOpenIs , iIndexARR , iIndexNavigate , iIndexNavigateFlag , iWmHwnd , iHmHwnd
Dim Shared As Integer iCommandParam , iSharedPanedPosition , iCurentEnc , iCurentEncParam = -1
Redim Shared As TPAGE tpages()
Redim Shared As TNAMEPATH szArrKeyWords()
Redim Shared As Zstring*256 szArrFiles(200) ,  szArrFilesLcase()
Dim Shared As HBITMAP bmp_ul0,bmp_ul1,bmp_li,bmp_do,bmp_dp,bmp_zi,bmp_zo,bmp_undo,bmp_redo , bmp_sc , bmp_h
Dim Shared As String szHHC , szHHK, szFirstFile , sCommand , sCommArr(3)
Dim Shared As String sDataHtml , sLastPathPage , sFileChmGlobalName , sFileChmGlobalTopicPath
Dim Shared As Long iwPrev , ihPrev , sFirstLoadPageForEnableSecurityAccess

Dim Shared As String sHelpInfo 
sHelpInfo = " " & Chr(10) & _
"CHMVIEW - open source utility for reading CHM files on linux system." & Chr(10) & _
"Written using the freebasic compiler: https://www.freebasic.net/" & Chr(10) & _
"Libraries used:" & Chr(10) & _
"window9: https://sourceforge.net/projects/guiwindow9/ , (including libwebkitgtk: https://webkitgtk.org/ )" & Chr(10) & _
"chmlib: http://www.jedrea.com/chmlib/"  & Chr(10) & _
"Utility author: Stanislav Budinov" & Chr(10) & Chr(10) & _
"USAGE: CHMVIEW [params] <file.chm>" & Chr(10) & Chr(10) & _
Chr(9) &"[params]:" & Chr(10) & _
Chr(9) & Chr(9) & "-h" & Chr(9) & Chr(9) & "curent help" & Chr(10) & Chr(10) & _
Chr(9) & Chr(9) & "-p <file.html>" & Chr(9) & Chr(9) & "open page file.html" & Chr(10) & Chr(10) & _
Chr(9) & Chr(9) & "-k <anykeyword>" & Chr(9) & Chr(9) & "open page containing anykeyword" & Chr(10) & Chr(10) & _
Chr(9) & Chr(9) & "-f <anykeyword>" & Chr(9) & Chr(9) & "find anykeyword ; print 1 if found" & Chr(10) & Chr(10) & _
Chr(9) & Chr(9) & "-e <encoding>" & Chr(9) & Chr(9) & "set specified encoding" & Chr(10) & Chr(10) & _
Chr(9) & Chr(9) & "-lp" & Chr(9) & Chr(9) & "list all pages htm/html" & Chr(10) & Chr(10) & _
Chr(9) & Chr(9) & "-lk" & Chr(9) & Chr(9) & "list all keywords" & Chr(10) & Chr(10) & _
Chr(9) & Chr(9) & "-la" & Chr(9) & Chr(9) & "list all files" & Chr(10) & Chr(10) & _
Chr(9) & Chr(9) & "-le" & Chr(9) & Chr(9) & "list all encoding" & Chr(10) & Chr(10) & _
Chr(9) & Chr(9) & "-g" & Chr(9) & Chr(9) & "save all files in dir: /tmp/tempCHM" & Chr(10)

Dim Shared As Zstring*21 szEncodingString(21) = {_
"UTF-8",_
"UTF-16",_
"KOI8-R",_
"KOI8-U",_
"KOI8-RU",_
"CP1250",_
"CP1251",_
"CP1252",_
"CP1253",_
"CP1254",_
"CP1255",_
"CP1256",_
"CP1257",_
"CP1258",_
"GBK",_
"GB18030",_
"EUC-KR",_
"EUC-JP",_
"BIG5",_
"BIG5-HKSCS",_
"SHIFT_JIS",_
"TIS-620" _
}