Function convertBytesData(Byval pData As Ubyte Ptr , Byval iSizeDataFrom As Integer, Byref iSizeDataReturn As Integer, Byval pszEncFrom As Zstring Ptr , Byval pszEncTo As Zstring Ptr) As Ubyte Ptr
	
	Dim As Any Ptr any_pfIconv
	
	Dim As Ubyte Ptr pSourceData , pTargetData , pTempTarget , pTempSource
	
	Dim As Integer iSizeDataIn , iSizeDataInBackup , iFlagAlloc	= 1
	
	any_pfIconv = iconv_open(pszEncTo, pszEncFrom)
	
	If any_pfIconv = Cast(Any Ptr,-1) Then
		
		? "Error iconv_open"
		
		Return 0
		
	Endif
	
	Select Case *pszEncFrom
		
		Case "UTF-32LE" , "UCS-4LE" , "UTF-32","UCS-4","UCS-4-INTERNAL"
		
			pSourceData  = Callocate(iSizeDataFrom + 4)
		
			*Cast(Long Ptr,pSourceData) = &hFEFF
		
			memcpy((pSourceData+4), pData , iSizeDataFrom)	
		
			iSizeDataFrom +=4
		
		Case "UTF-32BE","UCS-4BE"
		
			pSourceData  = Callocate(iSizeDataFrom + 4)
		
			*Cast(Long Ptr,pSourceData) = &hFFFE0000
		
			memcpy((pSourceData+4), pData , iSizeDataFrom)
		
			iSizeDataFrom +=4	
		
		Case "UTF-16LE" , "UCS-2LE"	, "UTF-16" , "UCS-2" , "UCS-2-INTERNAL"
		
			pSourceData  = Callocate(iSizeDataFrom + 2)
		
			*Cast(Short Ptr,pSourceData) = &hFEFF
		
			memcpy((pSourceData+2), pData , iSizeDataFrom)	
		
			iSizeDataFrom +=2			
		
		Case "UTF-16BE" , "UCS-2BE"
		
			pSourceData  = Callocate(iSizeDataFrom + 2)
		
			*Cast(Short Ptr,pSourceData) = &hFFFE
		
			memcpy((pSourceData+2), pData , iSizeDataFrom)
		
			iSizeDataFrom +=2
		
		Case Else
		
			pSourceData = pData
		
			iFlagAlloc = 0
		
	End Select
	
	pTempSource = pSourceData
	
	iSizeDataIn = iSizeDataFrom*6
	
	iSizeDataInBackup = iSizeDataIn	
	
	pTargetData = Callocate(iSizeDataIn + 3)
	
	pTempTarget = pTargetData
	
	If iconv(any_pfIconv, @pSourceData, Cast(Any Ptr,@iSizeDataFrom), @pTempTarget, Cast(Any Ptr,@iSizeDataIn)) = Cast(Any Ptr , -1) Then
		
		? "Error iconv"
		
		Return 0
		
	Endif
	
	iSizeDataReturn = iSizeDataInBackup-iSizeDataIn
	
	Function = pTargetData
	
	iconv_close(any_pfIconv)
	
	If iFlagAlloc Then
		
		Deallocate pTempSource
		
		If iSizeDataReturn > 3 Then
			
			Dim As Long iUnicode
			
			iUnicode = Cast(Long Ptr,pTargetData)[0]
			
			If iUnicode <> 0 Andalso ((iUnicode And &hFFFFFF) = &hBFBBEF  Orelse (iUnicode And &hFFFFFF) = &hFEFF  Orelse (iUnicode And &hFFFFFF) = &hFFFE) Then
				
				pTempSource = Callocate(iSizeDataReturn - 3)
				
				memcpy(pTempSource, (pTargetData+3) , iSizeDataReturn - 3)
				
				iSizeDataReturn -= 3
				
				Deallocate pTargetData
				
				Return pTempSource				
				
			Endif
			
		Endif
		
	Endif
	
End Function

Function encodeBuf(Byval pData As Ubyte Ptr , Byval iSizeDataFrom As Integer, Byref iSizeDataReturn As Integer, Byval pszEncFrom As Zstring Ptr , Byval pszEncTo As Zstring Ptr) As Ubyte Ptr
	
	Select Case Left(*pszEncFrom,3)
		
		Case "UCS" , "UTF"
		
			If Left(*pszEncTo,2) = "CP" Orelse Left(*pszEncTo,3) = "ISO" Then
			
				Dim As Ubyte Ptr p = convertBytesData(pData , iSizeDataFrom , iSizeDataReturn , pszEncFrom , "UTF-8") , p0
			
				p0=p
			
				Function = convertBytesData(p , iSizeDataReturn , iSizeDataReturn ,  "UTF-8", pszEncTo)
			
				Deallocate (p0)
			
			Else
			
				Function = convertBytesData(pData , iSizeDataFrom , iSizeDataReturn , pszEncFrom , pszEncTo)
			
			Endif
		
		Case Else
		
			Function = convertBytesData(pData , iSizeDataFrom , iSizeDataReturn , pszEncFrom , pszEncTo)
		
	End Select
	
End Function

Sub set_encoding()
	
	For i As Long = 0 To Ubound(tpages)
			
		Dim As Integer iSizeData = Len(tpages(i).szName) , iRet
		
		If iSizeData Then
			
			Dim As Zstring Ptr sData = encodeBuf(Strptr(tpages(i).szName) , iSizeData , iRet , szEncodingString(iCurentEnc) , "")
			
			Dim As String sEnc = *sData
			
			Deallocate(sData)
			
			Settextitemtreeview(E_TREE , tpages(i).h , sEnc)

		Endif
		
	Next
	
	For i As Long = 0 To Countitemlistbox(E_LISTBOX_INDEX)-1
			
		Dim As Integer iSizeData = Len(szArrKeyWords(i).szName) , iRet
		
		If iSizeData Then
			
			Dim As Zstring Ptr sData = encodeBuf(Strptr(szArrKeyWords(i).szName) , iSizeData , iRet , szEncodingString(iCurentEnc) , "")
			
			Dim As String sEnc = *sData
			
			Deallocate(sData)
			
			Setlistboxitemtext(E_LISTBOX_INDEX , sEnc ,  i )

		Endif
		
	Next
	
	Webgadgetnavigate(web , "about:blank")
	
	Updateinfoxserver()
	
	webkit_web_view_set_custom_encoding(web , szEncodingString(iCurentEnc))
	
	Updateinfoxserver()
	
	displayhtml(sLastPathPage)
	
	Updateinfoxserver()
	
End Sub

Function S_Lcase(sText As String) As String
   
   Dim As Ubyte Ptr pBytes = Sadd(sText)
   
   Dim As Integer iNBytes
   
   Dim As Long pwByte
   
   For i As Integer = 0 To Len(sText)-1
      
      iNBytes = mbtowc(Cast(Any Ptr,@pwByte), pBytes+i, 6)
      
      pwByte = towlower(pwByte)
      
      wctomb(pBytes+i, pwByte)
      
      If iNBytes > 1 Then 
         
         i = i + (iNBytes - 1)
         
      Endif      
      
   Next
   
   Return sText
   
End Function