
Declare Sub tree_add_node(x As Long, Byref MyTree As Node Ptr)

Declare Function tree_find_node(ikey As Long, MyTree As Node Ptr) As Node Ptr

Declare Sub size_allocate_signals Cdecl(Gwindow As GtkWidget Ptr, allocation As GdkRectangle Ptr, user_data As gpointer)

Function move_paned Cdecl(w  As Any Ptr , pAny As Any Ptr, p As gObject) As gboolean
	
	Dim As gint iMax , iMin , iCurPos
	
	Dim As gint Ptr iCurSavePos
	
	If *(Cast(Zstring Ptr,g_object_get_data(w, "ORI"))) = "V" Then
		
		iCurSavePos = g_object_get_data(w, "position_prev_V")
		
	Else
		
		iCurSavePos = g_object_get_data(w, "position_prev_H")
		
	Endif
	
	g_object_get(w, "max-position", @iMax, "min-position", @iMin, NULL)
	
	iCurPos = gtk_paned_get_position(w)
	
	If iCurPos <> *iCurSavePos Andalso iCurPos <> -1 Then
		
		If iCurPos <= iMin  Orelse iCurPos >= iMax  Then
			
			If iCurPos-1 >=0 Then
				
				gtk_paned_set_position(w , iCurPos-1)
				
			Endif
			
			Return 0
			
		Else
			
			Dim As Any Ptr hChild1 , hChild2
			
			Dim As Long iGadget1 , iGadget2 
			
			hChild1 = g_object_get_data(w, "gad1")
			
			hChild2 = g_object_get_data(w, "gad2")
			
			If hChild1 Andalso hChild2 Then
				
				iGadget1 = Id_in_number(hChild1)
				
				iGadget2 = Id_in_number(hChild2)
				
				If *(Cast(Zstring Ptr,g_object_get_data(w, "ORI"))) = "V" Then
					
					gtk_widget_set_size_request( hChild1 , Cint(g_object_get_data (Cast(Any Ptr, hChild1), "W_SIZE")) ,	iCurPos)
					
					g_object_set_data (Cast(Any Ptr, hChild1), "H_SIZE" , Cast(Any Ptr,Cint(iCurPos)))
					
					gtk_widget_set_size_request( hChild2 , Cint(g_object_get_data (Cast(Any Ptr, hChild2), "W_SIZE")) ,	iMax - iCurPos +5)
					
					g_object_set_data (Cast(Any Ptr, hChild1), "H_SIZE" , Cast(Any Ptr,Cint(iMax - iCurPos + 5)))
					
					Resizegadget(E_TREE , 0 , 0 ,  , iCurPos )
					
					Resizegadget(E_WEB , 0 , 0 , ,  iMax - iCurPos)
					
				Else	
					
					If iCurPos > -1 Then
					
						gtk_widget_set_size_request( hChild1  ,	iCurPos , Cint(g_object_get_data (Cast(Any Ptr, hChild1), "H_SIZE")))
						
						g_object_set_data (Cast(Any Ptr, hChild1), "W_SIZE" , Cast(Any Ptr,Cint(iCurPos)))
						
						gtk_widget_set_size_request( hChild2 ,	iMax - iCurPos , Cint(g_object_get_data (Cast(Any Ptr, hChild2), "H_SIZE")))
						
						g_object_set_data (Cast(Any Ptr, hChild1), "W_SIZE" , Cast(Any Ptr,Cint(iMax - iCurPos)))

						Resizegadget(E_PANEL , 0 , 0 , iCurPos )
					
					Endif
					
					If iCurPos-10 > -1 Then
						
						Resizegadget(E_LISTBOX_INDEX , 0 , 50 , iCurPos-10 )
						
						Resizegadget(E_STRING_INDEX , 0 , 10 , iCurPos-10 )
						
						Resizegadget(E_LISTBOX_SEARCH , 0 , 50 , iCurPos-10 )
						
						Resizegadget(E_TREE , 0 , 0 , iCurPos-10 )
						
					Endif
					
					If iCurPos-58 > -1 Then
					
						Resizegadget(E_STRING_SEARCH , 0 , 10 , iCurPos-58 )
						
						Resizegadget(E_BUTTON_SEARCH , iCurPos-53 , 10 , 35,30)
					
					Endif
					
					Resizegadget(E_WEB , 0 , 0 , iMax - iCurPos)
					
				Endif
				
				*iCurSavePos = iCurPos
				
			Endif
			
		Endif
		
	Endif
	
	Return 0
	
End Function

Sub PanedGadgetAddGadget(iGadgetPanned As Long , iGadgetChild1 As Long , iGadgetChild2 As Long) Export
	
	Dim As Any Ptr pan , child1 , child2
	
	pan = Gadgetid(iGadgetPanned)
	
	child1 = Gadgetid(iGadgetChild1)
	
	child2 = Gadgetid(iGadgetChild2)
	
	gtk_paned_add1 (GTK_PANED (pan), child1)
	
	gtk_paned_add2 (GTK_PANED (pan), child2)
	
	g_object_set_data (Cast(Any Ptr, pan), "gad1" , Cast(Any Ptr,child1))
	
	g_object_set_data (Cast(Any Ptr, pan), "gad2" , Cast(Any Ptr,child2))
	
End Sub

Function PanedGadget(iGadget As Long , iX As Long , iY As Long , iWidth As Long , iHeight As Long, iPos As Long , iStyle As Long = 0) As HWND Export
	
	Dim As HWND LayoutContainer , vBox , mainBox , eventbox 
	
	Dim As ListT Ptr pListTemp
	
	Freegadget(iGadget)
	
	pGlobalTypeWindow9->OptGroup = 0 ' reset Group OptionGadget
	
	pListTemp = Cast(ListT Ptr,pGlobalTypeWindow9->ListWinAndContainers->findNodeFunc(Cint(pGlobalTypeWindow9->CurentHwnd)))
	
	mainBox = Cast(hwnd , pListTemp->anyTwoData)	
	
	vbox = gtk_fixed_new()
	
	gtk_container_add (GTK_CONTAINER(mainBox), vbox)	
	
	If iStyle Then
		
		LayoutContainer = gtk_hpaned_new ()
		
		g_object_set_data(Cast(Any Ptr,LayoutContainer), "ORI", Cast(Any Ptr, @"H"))
		
	Else
		
		LayoutContainer = gtk_vpaned_new ()
		
		g_object_set_data(Cast(Any Ptr,LayoutContainer), "ORI", Cast(Any Ptr, @"V"))
		
	Endif
	
	pGlobalTypeWindow9->ListGadgets->addNodeSub(iGadget , Cint(LayoutContainer) ,  28)
	
	gtk_widget_set_size_request(LayoutContainer, iWidth, iHeight)
	
	gtk_fixed_put(GTK_FIXED(vbox), LayoutContainer, iX , iY)
	
	g_object_set_data (Cast(Any Ptr, LayoutContainer), "X_SIZE" , Cast(Any Ptr,Cint(iX)))
	
	g_object_set_data (Cast(Any Ptr, LayoutContainer), "Y_SIZE" , Cast(Any Ptr,Cint(iY)))
	
	g_object_set_data (Cast(Any Ptr, LayoutContainer), "W_SIZE" , Cast(Any Ptr,Cint(iWidth)))
	
	g_object_set_data (Cast(Any Ptr, LayoutContainer), "H_SIZE" , Cast(Any Ptr,Cint(iHeight)))	
	
	tree_add_node(iGadget,pGlobalTypeWindow9->treeNumberGadgets)
	
	Dim As Node Ptr fNode = tree_find_node(iGadget,pGlobalTypeWindow9->treeNumberGadgets)	
	
	g_signal_connect(G_OBJECT(LayoutContainer), "size-allocate", G_CALLBACK (@size_allocate_signals), @(fNode->x))
	
	g_signal_connect(G_OBJECT(LayoutContainer), "notify::position", G_CALLBACK (@move_paned), @(fNode->x))
	
	Static As gint iPV = 0
	
	Static As gint iPH = 0
	
	iPV = iPos
	
	iPH = iPos
	
	g_object_set_data(Cast(Any Ptr,LayoutContainer), "position_prev_V", Cast(Any Ptr, @iPV))
	
	g_object_set_data(Cast(Any Ptr,LayoutContainer), "position_prev_H", Cast(Any Ptr, @iPH))
	
	g_object_set(LayoutContainer, "position", iPos,  NULL)
	
	pGlobalTypeWindow9->ListWinAndContainers->addNodeSub( Cint(LayoutContainer) , Cint(LayoutContainer) )
	
	gtk_widget_show_all (pGlobalTypeWindow9->CurentHwnd)
	
	pGlobalTypeWindow9->CurentHwnd = LayoutContainer
	
	Return LayoutContainer
	
End Function

Function resize_containers(w2 As Any Ptr , x As Long  = FB_IGNORE, y As Long = FB_IGNORE, width_ As Long  = FB_IGNORE, height As Long = FB_IGNORE) As Integer	
	
	Dim As Any Ptr w3 = gtk_widget_get_parent(w2)
	
	If x = FB_IGNORE Then x = Cint(g_object_get_data (Cast(Any Ptr, w2), "X_SIZE"))
	
	If y = FB_IGNORE Then y = Cint(g_object_get_data (Cast(Any Ptr, w2), "Y_SIZE"))
	
	If width_ = FB_IGNORE Then width_ = Cint(g_object_get_data (Cast(Any Ptr, w2), "W_SIZE"))
	
	If height = FB_IGNORE Then height = Cint(g_object_get_data (Cast(Any Ptr, w2), "H_SIZE"))	
	
	gtk_fixed_move(GTK_FIXED(w3), w2, x , y)
	
	gtk_widget_set_size_request(w2 , width_ ,	height)
	
	g_object_set_data (Cast(Any Ptr, w2), "X_SIZE" , Cast(Any Ptr,Cint(x)))
	
	g_object_set_data (Cast(Any Ptr, w2), "Y_SIZE" , Cast(Any Ptr,Cint(y)))
	
	g_object_set_data (Cast(Any Ptr, w2), "W_SIZE" , Cast(Any Ptr,Cint(width_)))
	
	g_object_set_data (Cast(Any Ptr, w2), "H_SIZE" , Cast(Any Ptr,Cint(height)))
	
	Return True
	
End Function
