Sub set_treeitem_after_click(sPath As String)
	
	Dim As Long iFind = Instr(sPath , sDirChm)
	
	If iFind Then
		
		Dim As String sPartPath = Lcase(Mid(sPath , iFind+Len(sDirChm)+1))
		
		For i As Long = 0 To Ubound(tpages)
			
			If Lcase(tpages(i).szPath) = sPartPath Then
				
				sFileChmGlobalTopicPath = tpages(i).szPath
				
				If Getitemtreeview(E_TREE) <> tpages(i).h Then
					
					Setselecttreeviewitem(E_TREE , tpages(i).h)
					
				Endif
				
				Exit For
				
			Endif
			
		Next
		
	Endif
	
End Sub

#ifdef __USE_GTK3__
	
	Sub  getdatafunc_cb Cdecl(source_object As Gobject Ptr, res As GAsyncResult Ptr, user_data As gpointer )
		
		Dim As GError Ptr gerr
		
		Dim As gsize g_size
		
		sDataHtml = *webkit_web_resource_get_data_finish(source_object , res , @g_size,   @gerr)
		
	End Sub
	
	Sub load_changes_cb Cdecl (web_view As Any Ptr, load_event As Long, user_data As gpointer)
		
		If iOpenIs Andalso load_event = WEBKIT_LOAD_FINISHED Then
			
			Dim As Any Ptr resource = webkit_web_view_get_main_resource(web_view)
			
			If resource Then
				
				webkit_web_resource_get_data(resource , 0 , @getdatafunc_cb , 0)
				
			Endif
			
			set_treeitem_after_click(Webgadgetgeturl(web))
			
		Endif
		
	End Sub
	
#else
	
	Sub load_changes_cb (web_view As Any Ptr, frame As Any Ptr , user_data As gpointer)
		
		set_treeitem_after_click(*webkit_web_frame_get_uri(frame))
		
	End Sub
	
#endif

Sub navigate(sPath As String)
	
	Dim As String sTempValuePath = Lcase(sPath)
	
	For i As Long = 0 To Ubound(szArrFiles)
		
		If szArrFilesLcase(i) = sTempValuePath Then
			
			sTempValuePath = szArrFiles(i)
			
			iIndexNavigate = i
			
			Exit For
			
		Endif
		
	Next
	
	Dim As String sSep
	
	If Right(sPath , 1) <> "/" Then
		
		sSep = "/"
		
	Endif
	
	displayhtml(sDirChm & sSep & sTempValuePath)
	
End Sub

Sub getwebhtml()
	
	If iOpenIs Andalso dlgsc = 0 Then
		
		#ifdef __USE_GTK3__
			
			create_dialog_source_code(sDataHtml)
			
		#else
			
			Dim As String sData = Webgadgetgetbody(web)
			
			create_dialog_source_code(sData)
			
		#endif
		
	Endif
	
End Sub

Sub displayhtml(sPath As String)
	
	If Len(sPath) Then
		
		sLastPathPage = sPath
		
		Dim As String sTempPath = Lcase(sPath) , sAnchor
		
		Dim As Long iFind = Instr(sTempPath , ".html#")
		
		Dim As Long iFind2 = Instr(sTempPath , ".htm#")
		
		Dim As handle h
		
		If iFind Then
			
			sAnchor = Mid(sTempPath , iFind)
			
			sTempPath = Left(sPath , iFind+4)
			
		Elseif iFind2 Then
			
			sAnchor = Mid(sTempPath , iFind2)
			
			sTempPath = Left(sPath , iFind2+3)
			
		Else
			
			sTempPath = sPath
			
		Endif
		
		For i As Long = 0 To 2
			
			h = Read_file(sTempPath)
			
			If h = Cast(handle, -1) Andalso i = 0 Then
				
				sTempPath = xmlreplace_mnemonic(sTempPath)
				
				sTempPath = Replacestring(sTempPath , "%20" , " " , , 1)
				
				Dim As Integer iSizeData = Len(sTempPath) , iRet
				
				If iSizeData Then
					
					Dim As Zstring Ptr sData = encodeBuf(Strptr(sTempPath) , iSizeData , iRet , szEncodingString(iCurentEnc) , "")
					
					If sData Then
						
						sTempPath = *sData
						
						Deallocate(sData)
						
					Endif
					
				Endif
				
			Elseif h = Cast(handle, -1) Andalso i = 1 Then
				
				For i As Long = 0 To iIndexARR-1
					
					Dim As String s1 = sTempPath
					
					Dim As String s2 = S_Lcase(szArrFiles(i))
					
					S_Lcase(s1)
					
					S_Lcase(s2)
					
					If Len(s1) >=Len(s2) Andalso Right(s1 , Len(s2)) = s2 Then
						
						sTempPath = Mid(sTempPath , 1 , Len(sTempPath)- Len(szArrFiles(i))) & szArrFiles(i)
						
						Exit For
						
					Endif
					
				Next
				
			Else
				
				Exit For
				
			Endif
			
		Next
		
		If h <> Cast(handle, -1) Then
			
			Dim As Zstring Ptr psz = Read_datas(h , Size_file(h))
			
			If psz Then
				
				If iFind Orelse iFind2 Then
					
					For j As Long = 0 To Ubound(tpages)
						
						If Lcase(tpages(j).szAnchor) = sAnchor Then
							
							Dim As String sP
							
							If iFind Then
								
								sP = Left(sPath , iFind-1) & tpages(j).szAnchor
								
							Else
								
								sP = Left(sPath , iFind2-1) & tpages(j).szAnchor
								
							Endif
							
							If sFirstLoadPageForEnableSecurityAccess = 0 Then
								
								Webgadgetnavigate(web , "file://" & sP)
								
								sFirstLoadPageForEnableSecurityAccess = 1
								
							Endif
							
							webkit_web_view_load_html(web , psz , "file://" & sP)
							
						Endif
						
					Next
					
				Else
					
					If sFirstLoadPageForEnableSecurityAccess = 0 Then
						
						Webgadgetnavigate(web , "file://" & sPath)
						
						sFirstLoadPageForEnableSecurityAccess = 1
						
					Endif
					
					webkit_web_view_load_html(web , psz , "file://" & sPath)
					
				Endif
				
				Deallocate(psz)
				
			Endif
			
			Close_file(h)
			
		Endif
		
	Endif
	
End Sub