Function getStrTag (sStr As String , Byref iPos As Long ) As String
	
	Dim As String sRet
	
	Dim As Long iFind = Instr(iPos , sStr , ">") 
	
	If iFind Then
		
		sRet = Mid(sStr , iPos , iFind - iPos+1)
		
		iPos = iFind+1
		
	Else
	
		sRet = Mid(sStr , iPos)
		
		iPos = 0
		
	Endif
	
	Return sRet
	
End Function

Function xmlgetid(sStr As String) As Long
	
	Dim As String sTemp = Lcase(ClearSpace(sStr))
	
	If Instr(sTemp , "<ul>") Then
		
		Return 1
		
	Elseif Instr(sTemp, "<li>") Then
	
		Return 2
		
	Elseif Instr(sTemp, "name=" & Chr(34) & "name" & Chr(34)) Then
	
		Return 3
		
	Elseif Instr(sTemp, "name=" & Chr(34) & "local" & Chr(34)) Then
		
		Return 4
		
	Elseif Instr(sTemp, "</ul>") Then
		
		Return 5
		
	Endif
	
End Function

Function xmlgetvalue(sStr As String) As String
	
	Dim As String sTemp
	
	Dim As Long iFindStart = Instr(sStr , "value=" & Chr(34))
	
	Dim As Long iFindEnd = Instr(sStr , Chr(34) & ">")
	
	If iFindStart Andalso iFindEnd Then
		
		sTemp = Mid(sStr , iFindStart+7 , iFindEnd - (iFindStart+7))
		
		Return sTemp
		
	Endif
	
End Function

Function xmlreplace_mnemonic(sStr As String) As String
	
	Dim As String sPat
	
	Dim As Long iStart , iFindStart , iFindEnd , iEnc
	
	While 1
		
		iFindStart = Instr(iFindStart+1 , sStr , "&")
		
		If iFindStart Then
			
			iFindEnd = Instr(iFindStart+1 , sStr , ";")
			
			If iFindEnd Then
				
				sPat = Lcase(Mid(sStr , iFindStart , iFindEnd-iFindStart+1))
				
				For i As Long = 0 To Ubound(arr_mnem)
					
					If arr_mnem(i).sMnem = sPat Then

						sStr = Mid(sStr , 1 , iFindStart-1) & Chr(32) & Mid(sStr , iFindEnd+1)
						
						If arr_mnem(i).uni = 273 Then
							
							sStr[iFindStart-1] = 240
							
						Else
						
							sStr[iFindStart-1] = arr_mnem(i).uni
							
						Endif
						
						iEnc = 1
						
						Exit For
						
					Endif
					
				Next
				
			Else
			
				Exit While
				
			Endif
			
		Else
		
			Exit While
			
		Endif
		
	Wend
	
	Return sStr
	
End Function
